<template lang="pug">
q-page.overflow-hidden
  q-dialog(v-model="playVideo")
    q-card(style="width: 800px; max-width: 90vm")
      q-video(
        v-if="currentVideo",
        :src="getYouTube(currentVideo)",
        :ratio="currentVideo.type == 'hd_video' ? 16 / 9 : 1"
      )
      q-btn.full-width(
        :icon-right="matDownload",
        color="grey-5",
        dense,
        flat,
        type="a",
        :href="getNonTubeLink(currentVideo)",
        target="_blank"
      ) {{ $t('no_youtube') }}

  q-dialog(v-model="needsProfile", persistent)
    q-card.full-width
      q-card-section
        .text-h5.q-mb-sm {{ $t('your_name') }}
        q-input(
          autofocus,
          v-model="displayName",
          outlined,
          required,
          :rules="[(val) => !!val || '']"
        )
          template(v-slot:after)
            q-btn.full-width(
              flat,
              :icon="matCheck",
              color="positive",
              @click="displayName.length ? saveDisplayName() : false"
            )

  .q-ma-lg.text-center
    .col.photoframe.relative
      q-avatar(size="120px", style="margin-top: 60px")
        q-img.full-height(v-if="user.photoURL", :src="user.photoURL")
        q-icon.bg-grey-5(size="120px", :name="matPerson", color="white")
        q-input.hidden(
          type="file",
          ref="photofile",
          v-model="photofile",
          accept=".jpg"
        )
        q-btn.dim.absolute-center(
          @click="updatePhoto()",
          :icon="matFileUpload",
          dark,
          flat,
          round,
          v-if="ifCanChangeImage()"
        )
    .col
      .cursor-pointer
        .text-h4 {{ user.displayName }}
          q-popup-edit(
            @save="displayName.length ? saveDisplayName() : false",
            v-model="displayName",
            v-if="ifCanChangeImage()"
          )
            q-input(
              v-model="displayName",
              autofocus,
              required,
              outlined,
              :rules="[(val) => !!val || '']",
              :label="$t('your_name')"
            )
          q-icon.q-mb-lg.text-grey(
            :name="matEdit",
            size="xs",
            v-if="ifCanChangeImage()"
          )
      .text-body1.text-grey-6 {{ user.email }}

  div.bg-grey-2.q-pt-xs.q-pb-xl.q-mb-xl
    .text-center.text-uppercase.text-h5.q-my-xl {{ $t('how_to_submit') }}

    .row.text-center.justify-center.text-secondary.text-body1.q-px-md.q-px-md
      .col-md-2.col-12
        q-icon.rounder(
          :name="matUpload",
          :size="$q.screen.gt.md ? '36px' : '24px'"
        )
        div(:class="{ 'q-mb-md': $q.screen.lt.md }") {{ $t('pipeline1') }}
      .col-auto.dots(v-if="$q.screen.gt.sm")
        q-icon(:name="matMoreHoriz", size="40px")

      .col-md-2.col-12
        q-icon.rounder(
          :name="matPendingActions",
          :size="$q.screen.gt.md ? '36px' : '24px'"
        )
        div(:class="{ 'q-mb-md': $q.screen.lt.md }") {{ $t('pipeline2') }}
      .col-auto.dots(v-if="$q.screen.gt.sm")
        q-icon(:name="matMoreHoriz", size="40px")

      .col-md-2.col-12
        q-icon.rounder(
          :name="matAutoFixHigh",
          :size="$q.screen.gt.md ? '36px' : '24px'"
        )
        div(:class="{ 'q-mb-md': $q.screen.lt.md }") {{ $t('pipeline3') }}
      .col-auto.dots(v-if="$q.screen.gt.sm")
        q-icon(:name="matMoreHoriz", size="40px")

      .col-md-2.col-12
        q-icon.rounder(
          :name="matShare",
          :size="$q.screen.gt.md ? '36px' : '24px'"
        )
        div(:class="{ 'q-mb-md': $q.screen.lt.md }") {{ $t('pipeline4') }}

    .text-center.text-uppercase.text-h5.q-mb-xl.q-mt-lg {{ $t('instructions_title') }}
    .row.text-center.justify-center.q-mx-xl.q-mt-lg.text-body1
      .col-12
        .row
          .col-12
            ul.q-ml-none.q-pl-md.q-my-none
              li.nobullet(v-for="(message, index) in first", :key="index") {{ message }} <br /> &middot;

          .col-12
            ul.q-ml-none.q-pl-md.q-my-none
              li.nobullet(v-for="(message, index) in second", :key="index") {{ message }} <br /> &middot;
              li.nobullet {{ $t('instruction_agree') }} <br />
              a(href="/policy", target="_blank") {{ $t('terms_privacy_policy') }}

  .rip1.ripped.q-mt-xl(v-if="canSubmit && !loading")
    .text-center
      q-btn(
        unelevated,
        rounded,
        color="black",
        text-color="white",
        to="/submission/make",
        :size="$q.screen.gt.sm ? 'lg' : 'md'"
      )
        div(v-if="config.current_phase === 'submit'") {{ $t('submit_to', [$t('phase.phase_' + config.current_phase)]) }}
        div(v-if="config.current_phase !== 'submit'") {{ $t('upload_draft') }}
        q-icon(right, :name="matAdd")

    .q-ma-lg.text-center.text-body1.q-mb-xl.text-grey-7 {{ $t('submitinfo.phase_' + config.current_phase) }}

  .q-pa-md
    .row.pushdown.q-ml-xs
      q-timeline(color="secondary", :layout="layout", v-if="config")
        q-timeline-entry.relative(
          :title="$t('submissions_opened')",
          :subtitle="getTime(config.opensAt).toRelative()"
        )
          //- template(v-slot:subtitle)
          //-   .ripped.rip1
          //-   .mytitle {{ getTime(config.opensAt).toRelative() }}

        q-timeline-entry.relative(
          v-for="(phase, index) in phases",
          :key="phase.code",
          :icon="getIcon(phase)",
          :title="$t('phaseList.phase_' + phase.code)",
          :subtitle="getOpenCloseTime(phase).toRelative()",
          :side="index % 2 ? 'right' : 'left'"
        )
          //- template(v-slot:subtitle)
          //-   .ripped(:class="'rip' + (index + 2)")
          //-   .mytitle {{ getOpenCloseTime(phase).toRelative() }}
          SubmissionItem.q-mb-lg(
            :dir="layout != 'loose' ? 1 : index % 2",
            v-on:showvideo="showVideo($event, getSubmission(phase.code))",
            :submission="getSubmission(phase.code)",
            :config="config",
            v-if="getSubmission(phase.code)"
          )
          div(v-if="canSubmit && phase.code == config.current_phase")
            q-btn(
              unelevated,
              rounded,
              color="black",
              text-color="white",
              to="/submission/make",
              size="md"
            ) 
              div(v-if="config.current_phase === 'submit'") {{ $t('submit_now') }}
              div(v-if="config.current_phase !== 'submit'") {{ $t('upload_draft') }}
              q-icon(right, :name="matAdd")

        q-timeline-entry(
          :side="phases.length % 2 ? 'right' : 'left'",
          :title="$t('academy_opens')",
          :subtitle="getTime(config.closesAt).toRelative()"
        )
          //- template(v-slot:subtitle)
          //-   .ripped.rip1
          //-   .mytitle {{ getTime(config.opensAt).toRelative() }}
</template>

<script>
import { mapState, mapActions, mapGetters } from "vuex";
import filter from "lodash/filter";
import find from "lodash/find";
import orderBy from "lodash/orderBy";
import Language from "@/mixins/Language";
import SubmissionItem from "@/components/SubmissionItem";
import LocaleSwitcher from "@/components/LocaleSwitcher";
import { DateTime } from "luxon";

export default {
  mixins: [Language],
  name: "SubmissionList",
  components: {
    SubmissionItem,
    LocaleSwitcher,
  },
  async mounted() {
    await Promise.all([this.getSubmissions(), this.initConfig()]);
    this.loading = false;
  },
  data: () => {
    return {
      loading: true,
      playVideo: false,
      currentVideo: null,
      photofile: [],
      displayName: "",
      inlineloading: false,
    };
  },
  watch: {
    loading: {
      immediate: true,
      handler(val) {
        if (val) {
          this.$q.loading.show({
            delay: 400, // ms
          });
        } else {
          this.$q.loading.hide();
        }
      },
    },
    inlineloading: {
      handler(val) {
        if (val) {
          this.$q.loading.show({
            delay: 400, // ms
          });
        } else {
          this.$q.loading.hide();
        }
      },
    },
    async photofile() {
      try {
        this.inlineloading = true;
        // console.log(this.photofile);
        if (this.photofile[0]) {
          await this.updateUserPhoto(this.photofile[0]);
        }
      } catch (e) {
        console.log(e);
        this.showError("photo_upload_fail");
      }
      this.inlineloading = false;
    },
  },
  computed: {
    first() {
      return Object.values(this.messages.instructions).splice(
        0,
        Math.round(Object.values(this.messages.instructions).length / 2)
      );
    },
    second() {
      return Object.values(this.messages.instructions).splice(
        Math.round(Object.values(this.messages.instructions).length / 2),
        Math.round(Object.values(this.messages.instructions).length / 2)
      );
    },
    messages() {
      return this.$i18n.messages[this.$i18n.locale];
    },
    needsProfile() {
      return (
        this.ifCanChangeImage() && this.user.displayName === "Youth Innovator"
      );
    },
    layout() {
      return this.$q.screen.lt.sm
        ? "dense"
        : // : this.$q.screen.lt.md
          // ? "comfortable"
          "comfortable";
    },
    phases() {
      if (this.config) {
        let avail = filter(this.config.phases, "visible");
        return avail;
      } else {
        return [];
      }
    },
    ...mapState(["config", "submissions", "user"]),
    ...mapGetters(["canSubmit"]),
  },
  methods: {
    getIcon(phase) {
      // console.log(phase.icon);
      switch (phase.icon) {
        case "lightbulb":
          return this.matLightbulb;
        case "emoji_events":
          return this.matEmojiEvents;
        case "gavel":
          return this.matGavel;
        default:
          return phase.icon;
      }
    },
    getNonTubeLink(media) {
      if (!media) return "";
      if (!media.src) return "";
      return `${this.config.cloudfronturl}${media.src
        .replace("s3://", "")
        .replace(this.config.bucketname, "")
        .replace("hd_video", "hd_video_transcoded")}`;
    },
    async saveDisplayName() {
      try {
        this.inlineloading = true;
        // console.log(this.displayName);
        await this.updateUserDisplayName(this.displayName);
      } catch (e) {
        console.log(e);
        this.showError("photo_upload_fail");
      }
      this.inlineloading = false;
    },
    async updatePhoto() {
      this.$refs.photofile.$el.click();
    },
    ifCanChangeImage() {
      let isemail = find(this.user.providerData, { providerId: "password" });
      return isemail ? true : false;
    },
    getYouTube(media) {
      if (media.youtube)
        return `https://www.youtube.com/embed/${media.youtube}`;
      else return this.getNonTubeLink(media);
    },
    showVideo(kind, submission) {
      // console.log(kind);
      this.playVideo = true;
      this.currentVideo = find(submission.media, (media) => {
        if (media.type === kind && media.status !== "exporting") return true;
      });
    },
    getOpenCloseTime(phase) {
      if (this.getTime(phase.closesAt) < DateTime.now())
        return this.getTime(phase.closesAt);
      else return this.getTime(phase.opensAt);
    },
    isOpen(phase) {
      if (!phase) return false;
      return this.getTime(phase.opensAt) > DateTime.now();
    },
    getSubmission(code) {
      // console.log(code);
      // console.log(this.submissions);
      return find(orderBy(this.submissions, ["createdAt._seconds"], ["desc"]), {
        phase: code,
      });
    },
    ...mapActions([
      "signOutAction",
      "initConfig",
      "getSubmissions",
      "updateUserDisplayName",
      "updateUserPhoto",
    ]),
  },
};
</script>

<style src="@platyplus/humanitarian-icons/dist/icons.css">
/* global styles */
</style>

<style lang="scss">
.ripped {
  // opacity: 0.8;
  min-height: 250px;
  margin-bottom: 30px;
  // position: absolute;
  // right: 0;
  // left: 0;
  padding-top: 80px;
  // transform: translateY(-40%) translateX(-2em) scaleX(120%);
  // -webkit-transform: translate(-2em, -40%) scale(1.2, 1);
  // -o-transform: translate(-2em, -40%) scale(1.2, 1);
  // -moz-transform: translate(-2em, -40%) scale(1.2, 1);
  // z-index: -10;
  background-repeat: no-repeat;
  background-size: 100% 100%;

  // .q-timeline--comfortable & {
  //   min-height: 250px;
  //   position: absolute;
  //   right: 0;
  //   left: 0;
  //   transform: translateY(-40%) translateX(-2em) scaleX(120%);
  //   -webkit-transform: translate(-2em, -40%) scale(1.2, 1);
  //   -o-transform: translate(-2em, -40%) scale(1.2, 1);
  //   -moz-transform: translate(-2em, -40%) scale(1.2, 1);
  //   z-index: -10;
  //   background-repeat: no-repeat;
  //   background-size: 100% 100%;
  // }

  // .q-timeline--dense & {
  //   min-height: 100px;
  //   position: absolute;
  //   right: 0;
  //   left: 0;
  //   transform: translateY(-20%) translateX(-2em) scaleX(120%);
  //   -webkit-transform: translateY(-20%) translateX(-2em) scaleX(120%);
  //   -webkit-transform: translate(-2em, -20%) scale(1.2, 1);
  //   -o-transform: translate(-2em, -20%) scale(1.2, 1);
  //   -moz-transform: translate(-2em, -20%) scale(1.2, 1);
  //   // z-index: -1;
  //   background-repeat: no-repeat;
  //   background-size: 100% 100%;
  // }
}

.mytitle {
  .q-timeline--comfortable & {
    padding-bottom: 230px;
    opacity: 0.4;
  }

  .q-timeline--dense & {
    // padding-top: 0px;
    opacity: 0.4;
  }
}

.rip1 {
  background-image: url("~@/assets/img/rip1.jpg");
  // z-index: -1;
}

.rip2 {
  background-image: url("~@/assets/img/rip2.jpg");
  // z-index: -2;
}

.rip3 {
  background-image: url("~@/assets/img/rip4.jpg");
  // z-index: -3;
}

.rip4 {
  background-image: url("~@/assets/img/rip5.jpg");
  // z-index: -4;
}

.rip5 {
  background-image: url("~@/assets/img/rip6.jpg");
  // z-index: -5;
}

.dim {
  opacity: 0.6;
}

// .pushdown {
//   margin-top: 7em;
//   body.screen--xs & {
//     margin-top: 2em !important;
//   }
// }

// .q-timeline__subtitle {
//   opacity: 1 !important;
//   // color: white !important;
// }
</style>

<style>
.q-timeline__dot .q-icon {
  /* line-height: 30px; */
  height: 25px !important;
  /* width: 25px !important; */
  top: 7px !important;
  /* left: 5px !important; */
}

.photoframe {
  background-image: url("~@/assets/img/frame.png");
  background-position: center;
  background-size: contain;
  background-repeat: no-repeat;
  min-height: 240px;
}

.rounder {
  position: relative;
  border: 1px solid black;
  max-width: 75px;
  max-height: 75px;
  border-radius: 50%;
  padding: 15px;
  margin-bottom: 0.5em;
}

.dots {
  margin-top: 15px;
}

.nobullet {
  list-style: none;
}
</style>
